{

substitutes and additions of standard objects.pas
(c) 1995-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

23/12/99   + ReallocStr
31/12/99   + tStrLines
06/01/00    ReallocStr. if string empty then make nil pointer

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
unit rObjects;
interface
uses Objects, Strings;
const
{( Stream Blocks )}
 BlockSize       = $1000;
 TempSize        = $8000;
{( ? )}
 DefLimit        = 16;
 DefDelta        = 16;
 pSize           = SizeOf(Pointer);
 zr4: array[1..4] of Char = #0#0#0#0;
{( FileModes )}
 stDenyReadWrite: Word = $0010;
 stDenyAll      : Word = $0010;
 stDenyWrite    : Word = $0020;
 stDenyRead     : Word = $0030;
 stDenyNone     : Word = $0040;
{}
type
 tChar = Array[0..0] of Char;
{$IfDef VirtualPascal}
 prCollection = ^trCollection;
 trCollection = object(tCollection)
 end;
 prSortedCollection = ^trSortedCollection;
 trSortedCollection = object(tSortedCollection)
 end;
{$EndIf}
{$IfDef Ver70}
{( prCollection )}
 prCollection = ^trCollection;
 trCollection = object(TObject)
  Count,Limit,Delta: Longint;
  Sm: pStream;
  constructor Init(ALimit,aDelta: Longint);
  destructor  Done; virtual;
  procedure Insert(Item: Pointer); virtual;
  procedure AtInsert(Index: Longint; Item: Pointer);
  procedure AtDelete(Index: Longint);
  procedure DeleteAll;
  procedure AtFree(Index: Longint);
  procedure FreeAll;
  procedure FreeItem(Item: Pointer); virtual;
  procedure Error(Code, Info: Integer); virtual;
  function At(Index: Longint): Pointer;
 end;
{( prSortedCollection )}
 prSortedCollection = ^trSortedCollection;
 trSortedCollection = object(trCollection)
  Duplicates: Boolean;
  constructor Init(ALimit, ADelta: Integer);
  procedure Insert(Item: Pointer); virtual;
  function Search(Key: Pointer; var Index: Integer): Boolean; virtual;
  function Compare(Key1,Key2: Pointer): Integer; virtual;
 end;
{$EndIf}
{( tPos )}
 pPos = ^tPos;
 tPos = object(tObject)
  FromPos,ToPos: Longint;
  constructor Init(Newf,Newt: Longint);
 end;
{( tPosCol )}
 pPosCol = ^tPosCol;
 tPosCol = object(trSortedCollection)
  function Compare(Key1,Key2: Pointer): Integer; virtual;
 end;
{( tStrLines )}
 pStrLines = ^tStrLines;
 tStrLines = object(tCollection)
  procedure FreeItem(Item: Pointer); virtual;
 end;
{( tAscLines )}
 pAscLines = ^tAscLines;
 tAscLines = object(tCollection)
  procedure FreeItem(Item: Pointer); virtual;
 end;
{}
 function  CutStream(var Stream: tStream; FromPos,ToPos: Longint): Byte;
 function  NewCutStream(var Stream: tStream; WhatCol: tPosCol): Byte;
 function  InsertStream(var Dest: tStream; InsPos,InsSize: Longint): Byte;
 procedure DisposeObj(Var P);
{}
implementation
Uses rStrings, rAsciiz;
{( tPos )}
constructor TPos.Init;
 begin
  FromPos:=Newf;
  ToPos:=Newt;
 end;
{( tPosCol )}
function    tPosCol.Compare;
 var
  Pos1: pPos absolute Key1;
  Pos2: pPos absolute Key2;
 begin
  if Pos1^.FromPos<Pos2^.FromPos then Compare:=-1 else
   if Pos1^.FromPos=Pos2^.FromPos then Compare:=0 else
    if Pos1^.FromPos>Pos2^.FromPos then Compare:=1;
 end;
{$IfDef Ver70}
{( prCollection )}
constructor trCollection.Init;
 begin
  inherited Init;
  sm:=New(pMemoryStream,Init(0,BlockSize div 4));
{  sm:=New(pDosStream,Init('test',stCreate));}
  Count:=0;
  Limit:=aLimit;
  if Limit<=0 then Limit:=DefLimit;
  Delta:=aDelta;
  if Delta<=0 then Delta:=DefDelta;
 end;
{}
destructor  trCollection.Done;
 begin
  inherited Done;
  FreeAll;
  DisposeObj(Sm);
  Count:=0;
  Limit:=0;
  Delta:=0;
 end;
{}
procedure   trCollection.Insert;
 var
  x: Longint;
 begin
  with sm^ do
   begin
    if ((GetSize-GetPos) div pSize=0) then
     begin
      Seek(GetSize);
      for x:=1 to Delta do Write(zr4,SizeOf(zr4));
     end;
    Inc(Count);
    Seek(Longint((Count-1)*pSize));
    Write(Item,pSize);
   end;
 end;
{}
procedure   trCollection.AtInsert;
 begin
  if Index>Count then Error(coIndexError,0);
  Inc(Count);
  InsertStream(sm^,Longint(Index*pSize),4);
  with sm^ do
   begin
    Seek(Longint(Index*pSize));
    Write(Item,pSize);
   end;
 end;
{}
procedure   trCollection.AtDelete;
 begin
  if Index>Count-1 then Error(coIndexError,0);
  with sm^ do
   begin
    CutStream(sm^,Longint(Index*pSize),Longint(Index*pSize+pSize));
    Seek(Longint(Count*pSize));
    Dec(Count);
   end;
 end;
{}
procedure   trCollection.DeleteAll;
 begin
  with sm^ do
   begin
    Seek(0);
    Truncate;
    Count:=0;
   end;
 end;
{}
procedure   trCollection.AtFree;
 var
  p: Pointer;
 begin
  if Index>Count-1 then Error(coIndexError,0);
  p:=At(Index);
  AtDelete(Index);
  FreeItem(p);
 end;
{}
procedure   trCollection.FreeAll;
 var
  x: Longint;
 begin
  if Count=0 then Exit;
  with sm^ do
   begin
    for x:=0 to Count-1 do FreeItem(At(x));
    DeleteAll;
   end;
 end;
{}
procedure   trCollection.FreeItem;
 begin
  DisposeObj(pObject(Item));
 end;
{}
procedure   trCollection.Error;
begin
  RunError(212 - Code);
end;
{}
function    trCollection.At;
 var
  p: Pointer;
 begin
  if Index>Count-1 then Error(coIndexError,0);
  with sm^ do
   begin
    Seek(Longint((Index)*pSize));
    Read(p,pSize);
    Seek(Longint((Count)*pSize));
   end;
   At:=p;
 end;
{( trSortedCollection )}
constructor trSortedCollection.Init;
 begin
  inherited Init(ALimit,ADelta);
  Duplicates:=False;
 end;
{}
function    trSortedCollection.Search;
 var
  L,H,I,C: Integer;
 begin
  Search:=False;
  L:=0;
  H:=Count-1;
  while L<=H do
   begin
    I:=(L+H) shr 1;
    C:=Compare(At(I), Key);
    if C<0 then L:=I+1
    else
     begin
      H:=I-1;
      if C=0 then
       begin
        Search:=True;
        if not Duplicates then L:=I;
       end;
     end;
   end;
  Index:=L;
 end;
{}
procedure   trSortedCollection.Insert;
 var
  I: Integer;
 begin
  if not Search(Item,I) or Duplicates then AtInsert(I,Item);
 end;
{}
function    trSortedCollection.Compare;
 begin
  Abstract;
 end;
{$EndIf}
{( tStrLines )}
procedure tStrLines.FreeItem;
 begin
  ReallocStr(pString(Item),'');
 end;
{( tAscLines )}
procedure tAscLines.FreeItem;
 begin
  StrFree(pChar(Item));
 end;
{}
procedure   DisposeObj(Var P);
 begin
  if Pointer(p)<>nil then
   begin
    Dispose(PObject(P), Done);
    Pointer(P):=nil;
   end;
 end;
{}
function    CutStream(var Stream: tStream; FromPos,ToPos: Longint): Byte;
 var
  Shit: PMemoryStream;
  p,x: Longint;
 begin
  CutStream:=1;
  if FromPos>ToPos then exit;
  if @Stream=nil then Exit;
  if (FromPos>Stream.GetSize) or (ToPos>Stream.GetSize) then Exit;
  if Longint(Stream.GetSize-Abs(ToPos-FromPos))>MemAvail then exit;
  New(Shit,Init(0,TempSize));
  p:=Stream.GetPos;
  Stream.Seek(0);
  Shit^.CopyFrom(Stream, FromPos);
  Stream.Seek(ToPos);
  Shit^.CopyFrom(Stream, Stream.GetSize-ToPos);
  Shit^.Seek(0); Stream.Seek(0);
  Stream.CopyFrom(Shit^, Shit^.GetSize);
  Stream.Truncate;
  if (p<=ToPos) and (p>=FromPos) then p:=FromPos;
  if p>ToPos then p:=p-Abs(ToPos-FromPos)+1;
  Stream.Seek(p);
  DisposeObj(Shit);
  CutStream:=0;
 end;
{}
function    NewCutStream(var Stream: tStream; WhatCol: tPosCol): Byte;
 var
  Shit: PMemoryStream;
  PredTo: Longint;
  x: Integer;
  xPos: PPos;
 begin
  NewCutStream:=1;
  if @Stream=nil then exit;
  if WhatCol.Count<=0 then exit;
  if Stream.GetSize>MemAvail then exit;
  New(Shit,Init(0,TempSize));
  PredTo:=0;
  with WhatCol do for x:=0 to Count-1 do
   begin
    xPos:=At(x);
    with xPos^ do
     begin
      if FromPos>ToPos then Continue;
      if (FromPos>Stream.GetSize) or (ToPos>Stream.GetSize) then Break;
      if FromPos>PredTo then Dec(FromPos);
      Stream.Seek(PredTo);
      Shit^.Seek(Shit^.GetSize);
      if Abs(FromPos-PredTo)>0 then Shit^.CopyFrom(Stream, Abs(FromPos-PredTo));
      PredTo:=ToPos;
     end;
   end;
  Stream.Seek(PredTo);
  if Abs(Stream.GetSize-PredTo)>0 then Shit^.CopyFrom(Stream,Abs(Stream.GetSize-PredTo));
  Shit^.Seek(0); Stream.Seek(0);
  Stream.CopyFrom(Shit^, Shit^.GetSize);
  Stream.Truncate;
  DisposeObj(Shit);
  NewCutStream:=0;
 end;
{}
function    InsertStream(var Dest: tStream; InsPos,InsSize: Longint): Byte;
 var
  OldPos1,OldPos2: Longint;
  TempStream: PMemoryStream;
  x: Longint;
 begin
  InsertStream:=1;
  if (@Dest=nil) then Exit;
  if (InsPos>Dest.GetSize) then Exit;
  OldPos1:=Dest.GetPos;
  New(TempStream,Init(0,TempSize));
  Dest.Seek(InsPos);
  TempStream^.CopyFrom(Dest,Dest.GetSize-InsPos);
  Dest.Seek(InsPos);
  Dest.Truncate;
  for x:=1 to InsSize do Dest.Write(zr,1);
  TempStream^.Seek(0);
  Dest.CopyFrom(TempStream^,TempStream^.GetSize);
  if (OldPos1>=InsPos) then Inc(OldPos1,InsSize);
  Dest.Seek(OldPos1);
  DisposeObj(TempStream);
  InsertStream:=0;
 end;
{}
end.
